#pragma once

#ifndef _D2CONSTANTS_H
#define _D2CONSTANTS_H

/****************************************************************************
*                                                                           *
*   D2Constants.h                                                           *
*   Copyright (C) Olivier Verville                                          *
*                                                                           *
*   Licensed under the Apache License, Version 2.0 (the "License");         *
*   you may not use this file except in compliance with the License.        *
*   You may obtain a copy of the License at                                 *
*                                                                           *
*   http://www.apache.org/licenses/LICENSE-2.0                              *
*                                                                           *
*   Unless required by applicable law or agreed to in writing, software     *
*   distributed under the License is distributed on an "AS IS" BASIS,       *
*   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.*
*   See the License for the specific language governing permissions and     *
*   limitations under the License.                                          *
*                                                                           *
*---------------------------------------------------------------------------*
*                                                                           *
*   https://github.com/olivier-verville/D2Template                          *
*                                                                           *
*   This file is meant to declare various constant data. As you add more    *
*   custom code to your library, you will be using many constant values     *
*   used by the game's internal code. Unit types are a good example.        *
*   Declaring constants allows you to assign a name to these constants      *
*   which are more convenient to use in your source code.                   *
*                                                                           *
*   Another advantage is smaller impact in cases where these values would   *
*   need to change. Rather than revising every single piece of code using   *
*   this value, you only need to change your constant's value               *
*                                                                           *
*****************************************************************************/

//enum D2C_UnitTypes
//{
//    UNIT_PLAYER,        // 0 - Players
//    UNIT_MONSTER,       // 1 - Monsters
//    UNIT_OBJECT,        // 2 - Objects
//    UNIT_MISSILE,       // 3 - Missiles
//    UNIT_ITEM,          // 4 - Items
//    UNIT_TILE           // 5 - Tiles
//};

//typedef signed char        int8_t;
//typedef short              int16_t;
//typedef int                int32_t;
//typedef long long          int64_t;
//typedef unsigned char      uint8_t;
//typedef unsigned short     uint16_t;
//typedef unsigned int       uint32_t;
//typedef unsigned long long uint64_t;

//#define CELLNO_MYSHRINES 1176
//#define CELLNO_WAYPOINT 307
//#define CELLNO_SHRINE 310
//#define NUMOF_SHRINES 23
//#define OBJ_CHEST_LOCKED 0x80
//
//enum D2CStat
//{
//	STATS_STRENGTH = 0,
//	STATS_ENERGY,
//	STATS_DEXTERITY,
//	STATS_VITALITY,
//	STATS_STATPTS,
//	STATS_NEWSKILLS,
//	STATS_HP,
//	STATS_MAXHP,
//	STATS_MANA,
//	STATS_MAXMANA,
//	STATS_STAMINA,
//	STATS_MAXSTAMINA,
//	STATS_LEVEL,
//	STATS_EXPERIENCE,
//	STATS_GOLD,
//	STATS_GOLDBANK,
//	STATS_ITEM_ARMOR_PERCENT,//0x10
//	STATS_ITEM_MAXDAMAGE_PERCENT,
//	STATS_ITEM_MINDAMAGE_PERCENT,
//	STATS_TOHIT,
//	STATS_TOBLOCK,
//	STATS_MINDAMAGE,
//	STATS_MAXDAMAGE,
//	STATS_SECONDARY_MINDAMAGE,
//	STATS_SECONDARY_MAXDAMAGE,
//	STATS_DAMAGEPERCENT,
//	STATS_MANARECOVERY,
//	STATS_MANARECOVERYBONUS,
//	STATS_STAMINARECOVERYBONUS,
//	STATS_LASTEXP,
//	STATS_NEXTEXP,
//	STATS_ARMORCLASS,
//	STATS_ARMORCLASS_VS_MISSILE,//0x20
//	STATS_ARMORCLASS_VS_HTH,//0x21
//	STATS_NORMAL_DAMAGE_REDUCTION,
//	STATS_MAGIC_DAMAGE_REDUCTION,
//	STATS_DAMAGERESIST,
//	STATS_MAGICRESIST,
//	STATS_MAXMAGICRESIST,
//	STATS_FIRERESIST,//0x27
//	STATS_MAXFIRERESIST,
//	STATS_LIGHTRESIST,//0x29
//	STATS_MAXLIGHTRESIST,
//	STATS_COLDRESIST,//0x2B
//	STATS_MAXCOLDRESIST,
//	STATS_POISONRESIST,
//	STATS_MAXPOISONRESIST,
//	STATS_DAMAGEAURA,
//	STATS_FIREMINDAM,//0x30
//	STATS_FIREMAXDAM,
//	STATS_LIGHTMINDAM,
//	STATS_LIGHTMAXDAM,
//	STATS_MAGICMINDAM,
//	STATS_MAGICMAXDAM,
//	STATS_COLDMINDAM,
//	STATS_COLDMAXDAM,
//	STATS_COLDLENGTH,
//	STATS_POISONMINDAM,
//	STATS_POISONMAXDAM,
//	STATS_POISONLENGTH,
//	STATS_LIFEDRAINMINDAM,
//	STATS_LIFEDRAINMAXDAM,
//	STATS_MANADRAINMINDAM,
//	STATS_MANADRAINMAXDAM,
//	STATS_STAMDRAINMINDAM,//0x40
//	STATS_STAMDRAINMAXDAM,
//	STATS_STUNLENGTH,
//	STATS_VELOCITYPERCENT,
//	STATS_ATTACKRATE,
//	STATS_OTHER_ANIMRATE,
//	STATS_QUANTITY,
//	STATS_VALUE,
//	STATS_DURABILITY,
//	STATS_MAXDURABILITY,
//	STATS_HPREGEN,
//	STATS_ITEM_MAXDURABILITY_PERCENT,
//	STATS_ITEM_MAXHP_PERCENT,
//	STATS_ITEM_MAXMANA_PERCENT,
//	STATS_ITEM_ATTACKERTAKESDAMAGE,
//	STATS_ITEM_GOLDBONUS,
//	STATS_ITEM_MAGICBONUS,//0x50
//	STATS_ITEM_KNOCKBACK,
//	STATS_ITEM_TIMEDURATION,
//	STATS_ITEM_ADDCLASSSKILLS,							//STATS_ITEM_ADDAMASKILLPOINTS
//	STATS_UNSENTPARAM1,									//STATS_ITEM_ADDPALSKILLPOINTS
//	STATS_ADDEXPERIENCE,								//STATS_ITEM_ADDNECSKILLPOINTS
//	STATS_HEALAFTERKILL,								//STATS_ITEM_ADDSORSKILLPOINTS
//	STATS_REDUCESPRICES,								//STATS_ITEM_ADDBARSKILLPOINTS
//	STATS_ITEM_DOUBLEHERBDURATION,
//	STATS_ITEM_LIGHTRADIUS,
//	STATS_ITEM_LIGHTCOLOR,
//	STATS_ITEM_REQ_PERCENT,
//	STATS_LEVELREQ,										//STATS_ITEM_FASTATTACKRATE
//	STATS_ITEM_FASTERATTACKRATE,
//	STATS_ITEM_LEVELREQPCT,								//STATS_ITEM_FASTESTATTACKRATE,
//	STATS_LASTBLOCKFRAME,								//STATS_ITEM_FASTMOVEVELOCITY,
//	STATS_ITEM_FASTERMOVEVELOCITY,//0x60
//	STATS_NONCLASSKILL,									//STATS_ITEM_FASTESTMOVEVELOCITY,
//	STATS_STATE,										//STATS_ITEM_FASTGETHITRATE,
//	STATS_ITEM_FASTERGETHITRATE,
//	STATS_MONSTER_PLAYERCOUNT,							//STATS_ITEM_FASTESTGETHITRATE,
//	STATS_SKILL_POISON_OVERRIDE_LENGTH,					//STATS_ITEM_FASTBLOCKRATE,
//	STATS_ITEM_FASTERBLOCKRATE,
//	STATS_SKILL_BYPASS_UNDEAD,							//STATS_ITEM_FASTESTBLOCKRATE,
//	STATS_SKILL_BYPASS_DEMONS,							//STATS_ITEM_FASTCASTRATE,
//	STATS_ITEM_FASTERCASTRATE,
//	STATS_SKILL_BYPASS_BEASTS,							//STATS_ITEM_FASTESTCASTRATE,
//	STATS_ITEM_SINGLESKILL,								//STATS_ITEM_SINGLESKILL1,
//	STATS_ITEM_RESTINPEACE,								//STATS_ITEM_SINGLESKILL2,
//	STATS_CURSE_RESISTANCE,								//STATS_ITEM_SINGLESKILL3,
//	STATS_ITEM_POISONLENGTHRESIST,
//	STATS_ITEM_NORMALDAMAGE,
//	STATS_ITEM_HOWL,//0x70
//	STATS_ITEM_STUPIDITY,
//	STATS_ITEM_DAMAGETOMANA,
//	STATS_ITEM_IGNORETARGETAC,
//	STATS_ITEM_FRACTIONALTARGETAC,
//	STATS_ITEM_PREVENTHEAL,
//	STATS_ITEM_HALFFREEZEDURATION,
//	STATS_ITEM_TOHIT_PERCENT,
//	STATS_ITEM_DAMAGETARGETAC,
//	STATS_ITEM_DEMONDAMAGE_PERCENT,
//	STATS_ITEM_UNDEADDAMAGE_PERCENT,
//	STATS_ITEM_DEMON_TOHIT,
//	STATS_ITEM_UNDEAD_TOHIT,
//	STATS_ITEM_THROWABLE,
//	STATS_ITEM_ELEMSKILL,								//STATS_ITEM_FIRESKILL,
//	STATS_ITEM_ALLSKILLS,
//	STATS_ITEM_ATTACKERTAKESLIGHTDAMAGE,//0x80
//	STATS_IRONMAIDEN_LEVEL,
//	STATS_LIFETAP_LEVEL,
//	STATS_THORNS_LEVEL,
//	STATS_BONEARMOR,
//	STATS_BONEARMORMAX,
//	STATS_ITEM_FREEZE,
//	STATS_ITEM_OPENWOUNDS,
//	STATS_ITEM_CRUSHINGBLOW,
//	STATS_ITEM_KICKDAMAGE,
//	STATS_ITEM_MANAAFTERKILL,
//	STATS_ITEM_HEALAFTERDEMONKILL,
//	STATS_ITEM_EXTRABLOOD,
//	STATS_ITEM_DEADLYSTRIKE,
//	STATS_ITEM_ABSORBFIRE_PERCENT,
//	STATS_ITEM_ABSORBFIRE,
//	STATS_ITEM_ABSORBLIGHT_PERCENT,
//	STATS_ITEM_ABSORBLIGHT,
//	STATS_ITEM_ABSORBMAGIC_PERCENT,
//	STATS_ITEM_ABSORBMAGIC,
//	STATS_ITEM_ABSORBCOLD_PERCENT,
//	STATS_ITEM_ABSORBCOLD,
//	STATS_ITEM_SLOW,
//	STATS_ITEM_AURA,									//STATS_ITEM_BLESSEDAIM,
//	STATS_ITEM_INDESTRUCTIBLE,							//STATS_ITEM_DEFIANCE,
//	STATS_ITEM_CANNOTBEFROZEN,
//	STATS_ITEM_STAMINADRAINPCT,
//	STATS_ITEM_REANIMATE,
//	STATS_ITEM_PIERCE,
//	STATS_ITEM_MAGICARROW,
//	STATS_ITEM_EXPLOSIVEARROW,
//	STATS_ITEM_THROW_MINDAMAGE,
//	STATS_ITEM_THROW_MAXDAMAGE,
//	STATS_SKILL_HANDOFATHENA,
//	STATS_SKILL_STAMINAPERCENT,
//	STATS_SKILL_PASSIVE_STAMINAPERCENT,
//	STATS_SKILL_CONCENTRATION,
//	STATS_SKILL_ENCHANT,
//	STATS_SKILL_PIERCE,
//	STATS_SKILL_CONVICTION,
//	STATS_SKILL_CHILLINGARMOR,
//	STATS_SKILL_FRENZY,
//	STATS_SKILL_DECREPIFY,
//	STATS_SKILL_ARMOR_PERCENT,
//	STATS_ALIGNMENT,
//	STATS_TARGET0,
//	STATS_TARGET1,
//	STATS_GOLDLOST,
//	STATS_CONVERSION_LEVEL,
//	STATS_CONVERSION_MAXHP,
//	STATS_UNIT_DOOVERLAY,
//	STATS_ATTACK_VS_MONTYPE,							//STATS_ITEM_ADDDRUSKILLPOINTS,
//	STATS_DAMAGE_VS_MONTYPE,							//STATS_ITEM_ADDASSSKILLPOINTS,
//	STATS_FADE,											//STATS_ITEM_ADDSKILL_SINGLE4,
//	STATS_ARMOR_OVERRIDE_PERCENT,						//STATS_ITEM_ADDSKILL_SINGLE5,
//	STATS_UNUSED183,									//STATS_ITEM_ADDSKILL_SINGLE6,
//	STATS_UNUSED184,									//STATS_ITEM_ADDSKILL_SINGLE7,
//	STATS_UNUSED185,									//STATS_ITEM_ADDSKILL_SINGLE8,
//	STATS_UNUSED186,									//STATS_ITEM_ADDSKILL_SINGLE9,
//	STATS_UNUSED187,									//STATS_ITEM_ADDSKILL_SINGLE10,
//	STATS_ADDSKILL_TAB,									//STATS_ITEM_ADDSKILL_TAB1,
//	STATS_UNUSED189,									//STATS_ITEM_ADDSKILL_TAB2,
//	STATS_UNUSED190,									//STATS_ITEM_ADDSKILL_TAB3,
//	STATS_UNUSED191,									//STATS_ITEM_ADDSKILL_TAB4,
//	STATS_UNUSED192,									//STATS_ITEM_ADDSKILL_TAB5,
//	STATS_UNUSED193,									//STATS_ITEM_ADDSKILL_TAB6,
//	STATS_ITEM_NUMSOCKETS,
//	STATS_ITEM_SKILLONATTACK,							//STATS_ITEM_SKILLONATTACK1,
//	STATS_ITEM_SKILLONKILL,								//STATS_ITEM_SKILLONATTACK2,
//	STATS_ITEM_SKILLONDEATH,							//STATS_ITEM_SKILLONATTACK3,
//	STATS_ITEM_SKILLONHIT,								//STATS_ITEM_SKILLONHIT1,
//	STATS_ITEM_SKILLONLEVELUP,							//STATS_ITEM_SKILLONHIT2,
//	STATS_UNUSED200,									//STATS_ITEM_SKILLONHIT3,
//	STATS_ITEM_SKILLONGETHIT,							//STATS_ITEM_SKILLONGETHIT1,
//	STATS_UNUSED202,									//STATS_ITEM_SKILLONGETHIT2,
//	STATS_UNUSED203,									//STATS_ITEM_SKILLONGETHIT3,
//	STATS_ITEM_CHARGED_SKILL,							//STATS_ITEM_CHARGED_SKILL0,
//	STATS_UNUSED205,									//STATS_ITEM_CHARGED_SKILL1,
//	STATS_UNUSED206,									//STATS_ITEM_CHARGED_SKILL2,
//	STATS_UNUSED207,									//STATS_ITEM_CHARGED_SKILL3,
//	STATS_UNUSED208,									//STATS_ITEM_CHARGED_SKILL4,
//	STATS_UNUSED209,									//STATS_ITEM_CHARGED_SKILL5,
//	STATS_UNUSED210,									//STATS_ITEM_CHARGED_SKILL6,
//	STATS_UNUSED211,									//STATS_ITEM_CHARGED_SKILL7,
//	STATS_UNUSED212,									//STATS_ITEM_CHARGED_SKILL8,
//	STATS_UNUSED213,									//STATS_ITEM_CHARGED_SKILL9,
//	STATS_ITEM_ARMOR_PERLEVEL,
//	STATS_ITEM_ARMORPERCENT_PERLEVEL,
//	STATS_ITEM_HP_PERLEVEL,
//	STATS_ITEM_MANA_PERLEVEL,
//	STATS_ITEM_MAXDAMAGE_PERLEVEL,
//	STATS_ITEM_MAXDAMAGE_PERCENT_PERLEVEL,
//	STATS_ITEM_STRENGTH_PERLEVEL,
//	STATS_ITEM_DEXTERITY_PERLEVEL,
//	STATS_ITEM_ENERGY_PERLEVEL,
//	STATS_ITEM_VITALITY_PERLEVEL,
//	STATS_ITEM_TOHIT_PERLEVEL,
//	STATS_ITEM_TOHITPERCENT_PERLEVEL,
//	STATS_ITEM_COLD_DAMAGEMAX_PERLEVEL,
//	STATS_ITEM_FIRE_DAMAGEMAX_PERLEVEL,
//	STATS_ITEM_LTNG_DAMAGEMAX_PERLEVEL,
//	STATS_ITEM_POIS_DAMAGEMAX_PERLEVEL,
//	STATS_ITEM_RESIST_COLD_PERLEVEL,
//	STATS_ITEM_RESIST_FIRE_PERLEVEL,
//	STATS_ITEM_RESIST_LTNG_PERLEVEL,
//	STATS_ITEM_RESIST_POIS_PERLEVEL,
//	STATS_ITEM_ABSORB_COLD_PERLEVEL,
//	STATS_ITEM_ABSORB_FIRE_PERLEVEL,
//	STATS_ITEM_ABSORB_LTNG_PERLEVEL,
//	STATS_ITEM_ABSORB_POIS_PERLEVEL,
//	STATS_ITEM_THORNS_PERLEVEL,
//	STATS_ITEM_FIND_GOLD_PERLEVEL,
//	STATS_ITEM_FIND_MAGIC_PERLEVEL,
//	STATS_ITEM_REGENSTAMINA_PERLEVEL,
//	STATS_ITEM_STAMINA_PERLEVEL,
//	STATS_ITEM_DAMAGE_DEMON_PERLEVEL,
//	STATS_ITEM_DAMAGE_UNDEAD_PERLEVEL,
//	STATS_ITEM_TOHIT_DEMON_PERLEVEL,
//	STATS_ITEM_TOHIT_UNDEAD_PERLEVEL,
//	STATS_ITEM_CRUSHINGBLOW_PERLEVEL,
//	STATS_ITEM_OPENWOUNDS_PERLEVEL,
//	STATS_ITEM_KICK_DAMAGE_PERLEVEL,
//	STATS_ITEM_DEADLYSTRIKE_PERLEVEL,
//	STATS_ITEM_FIND_GEMS_PERLEVEL,
//	STATS_ITEM_REPLENISH_DURABILITY,
//	STATS_ITEM_REPLENISH_QUANTITY,
//	STATS_ITEM_EXTRA_STACK,
//	STATS_ITEM_FIND_ITEM,
//	STATS_ITEM_SLASH_DAMAGE,
//	STATS_ITEM_SLASH_DAMAGE_PERCENT,
//	STATS_ITEM_CRUSH_DAMAGE,
//	STATS_ITEM_CRUSH_DAMAGE_PERCENT,
//	STATS_ITEM_THRUST_DAMAGE,
//	STATS_ITEM_THRUST_DAMAGE_PERCENT,
//	STATS_ITEM_ABSORB_SLASH,
//	STATS_ITEM_ABSORB_CRUSH,
//	STATS_ITEM_ABSORB_THRUST,
//	STATS_ITEM_ABSORB_SLASH_PERCENT,
//	STATS_ITEM_ABSORB_CRUSH_PERCENT,
//	STATS_ITEM_ABSORB_THRUST_PERCENT,
//	STATS_ITEM_ARMOR_BYTIME,
//	STATS_ITEM_ARMORPERCENT_BYTIME,
//	STATS_ITEM_HP_BYTIME,
//	STATS_ITEM_MANA_BYTIME,
//	STATS_ITEM_MAXDAMAGE_BYTIME,
//	STATS_ITEM_MAXDAMAGE_PERCENT_BYTIME,
//	STATS_ITEM_STRENGTH_BYTIME,
//	STATS_ITEM_DEXTERITY_BYTIME,
//	STATS_ITEM_ENERGY_BYTIME,
//	STATS_ITEM_VITALITY_BYTIME,
//	STATS_ITEM_TOHIT_BYTIME,
//	STATS_ITEM_TOHITPERCENT_BYTIME,
//	STATS_ITEM_COLD_DAMAGEMAX_BYTIME,
//	STATS_ITEM_FIRE_DAMAGEMAX_BYTIME,
//	STATS_ITEM_LTNG_DAMAGEMAX_BYTIME,
//	STATS_ITEM_POIS_DAMAGEMAX_BYTIME,
//	STATS_ITEM_RESIST_COLD_BYTIME,
//	STATS_ITEM_RESIST_FIRE_BYTIME,
//	STATS_ITEM_RESIST_LTNG_BYTIME,
//	STATS_ITEM_RESIST_POIS_BYTIME,
//	STATS_ITEM_ABSORB_COLD_BYTIME,
//	STATS_ITEM_ABSORB_FIRE_BYTIME,
//	STATS_ITEM_ABSORB_LTNG_BYTIME,
//	STATS_ITEM_ABSORB_POIS_BYTIME,
//	STATS_ITEM_FIND_GOLD_BYTIME,
//	STATS_ITEM_FIND_MAGIC_BYTIME,
//	STATS_ITEM_REGENSTAMINA_BYTIME,
//	STATS_ITEM_STAMINA_BYTIME,
//	STATS_ITEM_DAMAGE_DEMON_BYTIME,
//	STATS_ITEM_DAMAGE_UNDEAD_BYTIME,
//	STATS_ITEM_TOHIT_DEMON_BYTIME,
//	STATS_ITEM_TOHIT_UNDEAD_BYTIME,
//	STATS_ITEM_CRUSHINGBLOW_BYTIME,
//	STATS_ITEM_OPENWOUNDS_BYTIME,
//	STATS_ITEM_KICK_DAMAGE_BYTIME,
//	STATS_ITEM_DEADLYSTRIKE_BYTIME,
//	STATS_ITEM_FIND_GEMS_BYTIME,
//	STATS_ITEM_PIERCE_COLD,
//	STATS_ITEM_PIERCE_FIRE,
//	STATS_ITEM_PIERCE_LTNG,
//	STATS_ITEM_PIERCE_POIS,
//	STATS_ITEM_DAMAGE_VS_MONSTER,
//	STATS_ITEM_DAMAGE_PERCENT_VS_MONSTER,
//	STATS_ITEM_TOHIT_VS_MONSTER,
//	STATS_ITEM_TOHIT_PERCENT_VS_MONSTER,
//	STATS_ITEM_AC_VS_MONSTER,
//	STATS_ITEM_AC_PERCENT_VS_MONSTER,
//	STATS_FIRELENGTH,
//	STATS_BURNINGMIN,
//	STATS_BURNINGMAX,
//	STATS_PROGRESSIVE_DAMAGE,
//	STATS_PROGRESSIVE_STEAL,
//	STATS_PROGRESSIVE_OTHER,
//	STATS_PROGRESSIVE_FIRE,
//	STATS_PROGRESSIVE_COLD,
//	STATS_PROGRESSIVE_LIGHTNING,
//	STATS_ITEM_EXTRA_CHARGES,
//	STATS_PROGRESSIVE_TOHIT,
//	STATS_POISON_COUNT,
//	STATS_DAMAGE_FRAMERATE,
//	STATS_PIERCE_IDX,
//	STATS_PASSIVE_FIRE_MASTERY,///////////////////////// NEW FOR 1.10
//	STATS_PASSIVE_LTNG_MASTERY,
//	STATS_PASSIVE_COLD_MASTERY,
//	STATS_PASSIVE_POUS_MASTERY,
//	STATS_PASSIVE_FIRE_PIERCE,
//	STATS_PASSIVE_LTNG_PIERCE,
//	STATS_PASSIVE_COLD_PIERCE,
//	STATS_PASSIVE_POIS_PIERCE,
//	STATS_PASSIVE_CRITICAL_STRIKE,
//	STATS_PASSIVE_DODGE,
//	STATS_PASSIVE_AVOID,
//	STATS_PASSIVE_EVADE,
//	STATS_PASSIVE_WARMTH,
//	STATS_PASSIVE_MASTERY_MELEE_TH,
//	STATS_PASSIVE_MASTERY_MELEE_DMG,
//	STATS_PASSIVE_MASTERY_MELEE_CRIT,
//	STATS_PASSIVE_MASTERY_THROW_TH,
//	STATS_PASSIVE_MASTERY_THROW_DMG,
//	STATS_PASSIVE_MASTERY_THROW_CRIT,
//	STATS_PASSIVE_WEAPONBLOCK,
//	STATS_PASSIVE_SUMMON_RESIST,
//	STATS_MODIFIERLIST_SKILL,
//	STATS_MODIFIERLIST_LEVEL,
//	STATS_LAST_SENT_HP_PCT,
//	STATS_SOURCE_UNIT_TYPE,
//	STATS_SOURCE_UNIT_ID,
//	STATS_SHORTPARAM1,
//	STATS_QUESTITEMDIFFICULTY,
//	STATS_PASSIVE_MAG_MASTERY,
//	STATS_PASSIVE_MAG_PIERCE
//};
//
//enum D2StatesTxt
//{
//	STATE_FREEZE = 0x1,
//	STATE_POISON = 0x2,
//	STATE_RESISTFIRE = 0x3,
//	STATE_RESISTCOLD = 0x4,
//	STATE_RESISTLIGHT = 0x5,
//	STATE_RESISTMAGIC = 0x6,
//	STATE_PLAYERBODY = 0x7,
//	STATE_RESISTALL = 0x8,
//	STATE_AMPLIFYDAMAGE = 0x9,
//	STATE_FROZENARMOR = 0xA,
//	STATE_COLD = 0xB,
//	STATE_INFERNO = 0xC,
//	STATE_BLAZE = 0xD,
//	STATE_BONEARMOR = 0xE,
//	STATE_CONCENTRATE = 0xF,
//	STATE_ENCHANT = 0x10,
//	STATE_INNERSIGHT = 0x11,
//	STATE_SKILL_MOVE = 0x12,
//	STATE_WEAKEN = 0x13,
//	STATE_CHILLINGARMOR = 0x14,
//	STATE_STUNNED = 0x15,
//	STATE_SPIDERLAY = 0x16,
//	STATE_DIMVISION = 0x17,
//	STATE_SLOWED = 0x18,
//	STATE_FETISHAURA = 0x19,
//	STATE_SHOUT = 0x1A,
//	STATE_TAUNT = 0x1B,
//	STATE_CONVICTION = 0x1C,
//	STATE_CONVICTED = 0x1D,
//	STATE_ENERGYSHIELD = 0x1E,
//	STATE_VENOMCLAWS = 0x1F,
//	STATE_BATTLEORDERS = 0x20,
//	STATE_MIGHT = 0x21,
//	STATE_PRAYER = 0x22,
//	STATE_HOLYFIRE = 0x23,
//	STATE_THORNS = 0x24,
//	STATE_DEFIANCE = 0x25,
//	STATE_THUNDERSTORM = 0x26,
//	STATE_LIGHTNINGBOLT = 0x27,
//	STATE_BLESSEDAIM = 0x28,
//	STATE_STAMINA = 0x29,
//	STATE_CONCENTRATION = 0x2A,
//	STATE_HOLYWIND = 0x2B,
//	STATE_HOLYWINDCOLD = 0x2C,
//	STATE_CLEANSING = 0x2D,
//	STATE_HOLYSHOCK = 0x2E,
//	STATE_SANCTUARY = 0x2F,
//	STATE_MEDITATION = 0x30,
//	STATE_FANATICISM = 0x31,
//	STATE_REDEMPTION = 0x32,
//	STATE_BATTLECOMMAND = 0x33,
//	STATE_PREVENTHEAL = 0x34,
//	STATE_CONVERSION = 0x35,
//	STATE_UNINTERRUPTABLE = 0x36,
//	STATE_IRONMAIDEN = 0x37,
//	STATE_TERROR = 0x38,
//	STATE_ATTRACT = 0x39,
//	STATE_LIFETAP = 0x3A,
//	STATE_CONFUSE = 0x3B,
//	STATE_DECREPIFY = 0x3C,
//	STATE_LOWERRESIST = 0x3D,
//	STATE_OPENWOUNDS = 0x3E,
//	STATE_DOPPLEZON = 0x3F,
//	STATE_CRITICALSTRIKE = 0x40,
//	STATE_DODGE = 0x41,
//	STATE_AVOID = 0x42,
//	STATE_PENETRATE = 0x43,
//	STATE_EVADE = 0x44,
//	STATE_PIERCE = 0x45,
//	STATE_WARMTH = 0x46,
//	STATE_FIREMASTERY = 0x47,
//	STATE_LIGHTNINGMASTERY = 0x48,
//	STATE_COLDMASTERY = 0x49,
//	STATE_SWORDMASTERY = 0x4A,
//	STATE_AXEMASTERY = 0x4B,
//	STATE_MACEMASTERY = 0x4C,
//	STATE_POLEARMMASTERY = 0x4D,
//	STATE_THROWINGMASTERY = 0x4E,
//	STATE_SPEARMASTERY = 0x4F,
//	STATE_INCREASEDSTAMINA = 0x50,
//	STATE_IRONSKIN = 0x51,
//	STATE_INCREASEDSPEED = 0x52,
//	STATE_NATURALRESISTANCE = 0x53,
//	STATE_FINGERMAGECURSE = 0x54,
//	STATE_NOMANAREGEN = 0x55,
//	STATE_JUSTHIT = 0x56,
//	STATE_SLOWMISSILES = 0x57,
//	STATE_SHIVERARMOR = 0x58,
//	STATE_BATTLECRY = 0x59,
//	STATE_BLUE = 0x5A,
//	STATE_RED = 0x5B,
//	STATE_DEATH_DELAY = 0x5C,
//	STATE_VALKYRIE = 0x5D,
//	STATE_FRENZY = 0x5E,
//	STATE_BERSERK = 0x5F,
//	STATE_REVIVE = 0x60,
//	STATE_SKEL_MASTERY = 0x61,
//	STATE_SOURCEUNIT = 0x62,
//	STATE_REDEEMED = 0x63,
//	STATE_HEALTHPOT = 0x64,
//	STATE_HOLYSHIELD = 0x65,
//	STATE_JUST_PORTALED = 0x66,
//	STATE_MONFRENZY = 0x67,
//	STATE_CORPSE_NODRAW = 0x68,
//	STATE_ALIGNMENT = 0x69,
//	STATE_MANAPOT = 0x6A,
//	STATE_SHATTER = 0x6B,
//	STATE_SYNC_WARPED = 0x6C,
//	STATE_CONVERSION_SAVE = 0x6D,
//	STATE_PREGNANT = 0x6E,
//	STATE_GOLEM_MASTERY = 0x6F,
//	STATE_RABIES = 0x70,
//	STATE_DEFENSE_CURSE = 0x71,
//	STATE_BLOOD_MANA = 0x72,
//	STATE_BURNING = 0x73,
//	STATE_DRAGONFLIGHT = 0x74,
//	STATE_MAUL = 0x75,
//	STATE_CORPSE_NOSELECT = 0x76,
//	STATE_SHADOWWARRIOR = 0x77,
//	STATE_FERALRAGE = 0x78,
//	STATE_SKILLDELAY = 0x79,
//	STATE_PROGRESSIVE_DAMAGE = 0x7A,
//	STATE_PROGRESSIVE_STEAL = 0x7B,
//	STATE_PROGRESSIVE_OTHER = 0x7C,
//	STATE_PROGRESSIVE_FIRE = 0x7D,
//	STATE_PROGRESSIVE_COLD = 0x7E,
//	STATE_PROGRESSIVE_LIGHTNING = 0x7F,
//	STATE_SHRINE_ARMOR = 0x80,
//	STATE_SHRINE_COMBAT = 0x81,
//	STATE_SHRINE_RESIST_LIGHTNING = 0x82,
//	STATE_SHRINE_RESIST_FIRE = 0x83,
//	STATE_SHRINE_RESIST_COLD = 0x84,
//	STATE_SHRINE_RESIST_POISON = 0x85,
//	STATE_SHRINE_SKILL = 0x86,
//	STATE_SHRINE_MANA_REGEN = 0x87,
//	STATE_SHRINE_STAMINA = 0x88,
//	STATE_SHRINE_EXPERIENCE = 0x89,
//	STATE_FENRIS_RAGE = 0x8A,
//	STATE_WOLF = 0x8B,
//	STATE_BEAR = 0x8C,
//	STATE_BLOODLUST = 0x8D,
//	STATE_CHANGECLASS = 0x8E,
//	STATE_ATTACHED = 0x8F,
//	STATE_HURRICANE = 0x90,
//	STATE_ARMAGEDDON = 0x91,
//	STATE_INVIS = 0x92,
//	STATE_BARBS = 0x93,
//	STATE_WOLVERINE = 0x94,
//	STATE_OAKSAGE = 0x95,
//	STATE_VINE_BEAST = 0x96,
//	STATE_CYCLONEARMOR = 0x97,
//	STATE_CLAWMASTERY = 0x98,
//	STATE_CLOAK_OF_SHADOWS = 0x99,
//	STATE_RECYCLED = 0x9A,
//	STATE_WEAPONBLOCK = 0x9B,
//	STATE_CLOAKED = 0x9C,
//	STATE_QUICKNESS = 0x9D,
//	STATE_BLADESHIELD = 0x9E,
//	STATE_FADE = 0x9F,
//	STATE_SUMMONRESIST = 0xA0,
//	STATE_OAKSAGECONTROL = 0xA1,
//	STATE_WOLVERINECONTROL = 0xA2,
//	STATE_BARBSCONTROL = 0xA3,
//	STATE_DEBUGCONTROL = 0xA4,
//	STATE_ITEMSET1 = 0xA5,
//	STATE_ITEMSET2 = 0xA6,
//	STATE_ITEMSET3 = 0xA7,
//	STATE_ITEMSET4 = 0xA8,
//	STATE_ITEMSET5 = 0xA9,
//	STATE_ITEMSET6 = 0xAA,
//	STATE_RUNEWORD = 0xAB,
//	STATE_RESTINPEACE = 0xAC,
//	STATE_CORPSEEXP = 0xAD,
//	STATE_WHIRLWIND = 0xAE,
//	STATE_FULLSETGENERIC = 0xAF,
//	STATE_MONSTERSET = 0xB0,
//	STATE_DELERIUM = 0xB1,
//	STATE_ANTIDOTE = 0xB2,
//	STATE_THAWING = 0xB3,
//	STATE_STAMINAPOT = 0xB4,
//	STATE_PASSIVE_RESISTFIRE = 0xB5,
//	STATE_PASSIVE_RESISTCOLD = 0xB6,
//	STATE_PASSIVE_RESISTLTNG = 0xB7,
//	STATE_UBERMINION = 0xB8,
//};
//
//enum D2C_MenuImageLoadType
//{
//	CELLFILETYPE_DC6,
//	CELLFILETYPE_DCC,
//};
//
//enum D2C_DrawModes
//{
//	// Credits: Necrolis
//
//	DRAWMODE_TRANS25,
//	DRAWMODE_TRANS50,
//	DRAWMODE_TRANS75,
//	DRAWMODE_MODULATE,
//	DRAWMODE_BURN,
//	DRAWMODE_NORMAL,
//	DRAWMODE_TRANSHIGHLIGHT,
//	DRAWMODE_HIGHLIGHT
//};
//
//#define CELLNO_MYSHRINES 1176
//#define CELLNO_SHRINE 310
//#define NUMOF_SHRINES 23
//
//enum {
//	UNITNO_PLAYER = 0,
//	UNITNO_MONSTER = 1,
//	UNITNO_OBJECT = 2,
//	UNITNO_MISSILE = 3,
//	UNITNO_ITEM = 4,
//	UNITNO_ROOMTILE = 5
//};
//
//enum UpdateClientConst
//{
//	UC_SELECT_STASH=0x18,
//	UC_SHARED_GOLD,
//	UC_PAGE_NAME,
//	UC_ADD_STAT,
//	UC_ADD_SYNERGY,
//	UC_TEST1,
//	UC_TEST2,
//	UC_TEST3
//};
//
//enum UpdateServerConst
//{
//	US_UNASSIGN_STR_POINT=0x10,//Don't change these first 8 value
//	US_UNASSIGN_ENE_POINT,
//	US_UNASSIGN_DEX_POINT,
//	US_UNASSIGN_VIT_POINT,
//	US_UNASSIGN_STR_POINTS,
//	US_UNASSIGN_ENE_POINTS,
//	US_UNASSIGN_DEX_POINTS,
//	US_UNASSIGN_VIT_POINTS,
//	US_UNASSIGN_SKILLS,
//	US_SELECT_PREVIOUS,
//	US_SELECT_NEXT,
//	US_SELECT_SELF,
//	US_SELECT_SHARED,
//	US_SELECT_PREVIOUS_INDEX,
//	US_SELECT_NEXT_INDEX,
//	US_SELECT_PREVIOUS2,
//	US_SELECT_NEXT2,
//	US_SELECT_PREVIOUS_INDEX2,
//	US_SELECT_NEXT_INDEX2,
//	US_WORLDEVENT,
//	US_SAVE,
//	US_MAXGOLD,
//	US_PUTGOLD,
//	US_TAKEGOLD,
//	US_RENAME,
//	US_PAGENAME,
//	US_SET_INDEX,
//	US_SET_MAIN_INDEX,
//	US_RESET_INDEX,
//	US_INSERT_PAGE,
//	US_DELETE_PAGE,
//	US_SWAP3,
//	US_SWAP2,
//	US_SWAP1,
//	US_SWAP0,
//	US_SWAP0_TOGGLE,
//	US_TOGGLE1,
//	US_TOGGLE2,
//	US_TOGGLE3,
//	//DONT USE, THIS FOR PLUGY ^^^^
//	US_TEST1,
//	US_TEST2,
//	US_TEST3,
//	US_TEST4,
//	US_TEST5,
//	US_TEST6
//};
//
//enum D2TypeSize         { D2TS_UNITSIZE = 0x011C };
//enum D2DifficultyModes  { D2DM_NORMAL, D2DM_NIGHTMARE, D2DM_HELL };
//enum D2PlayerClass      { D2PC_AMAZON, D2PC_SORCERESS, D2PC_NECROMANCER, D2PC_PALADIN, D2PC_BARBARIAN, D2PC_DRUID, D2PC_ASSASSIN };
//
//enum D2Color
//{
//	WHITE=0,
//	RED=1,
//	GREEN=2,
//	BLUE=3,
//	GOLD=4,
//	DARK_GRAY=5,
//	//	INVISIBLE=6,
//	DARK_YELLOW=7,
//	ORANGE=8,
//	YELLOW=9,
//	DARKEST_GREEN=0xA,
//	PURPLE=0xB,
//	DARK_GREEN=0xC,
//	//	WHITE_BIS=0xD,
//	//	INVISIBLE2=0xE,
//	LIGHT_GRAY=0xF,
//	GRAY=0x10,
//	//	VERY_WIERD=0x11,
//	BRIGHT_WHITE=0x12,
//	CRYSTAL_RED=0x13,
//	//	WIERD_YELLOW=0x14
//};
//
//enum D2Lang
//{
//	LNG_ENG=0,// English
//	LNG_ESP,// Spanish
//	LNG_DEU,// German
//	LNG_FRA,// French
//	LNG_POR,// Portuguese
//	LNG_ITA,// Italian
//	LNG_JPN,// Japanese
//	LNG_KOR,// Korean
//	LNG_SIN,//
//	LNG_CHI,// Chinese
//	LNG_POL,// Polish
//	LNG_RUS,// Russian
//	LNG_DEF,// Default : English
//};
//
//
//enum D2GameTypeMode
//{
//	//	MODE_SINGLE = 0,
//	MODE_CLOSED = 1,
//	MODE_TCP,
//	MODE_OPEN,
//};

//enum D2CStat
//{
//	STATS_STRENGTH = 0,
//	STATS_ENERGY,
//	STATS_DEXTERITY,
//	STATS_VITALITY,
//	STATS_STATPTS,
//	STATS_NEWSKILLS,
//	STATS_HP,
//	STATS_MAXHP,
//	STATS_MANA,
//	STATS_MAXMANA,
//	STATS_STAMINA,
//	STATS_MAXSTAMINA,
//	STATS_LEVEL,
//	STATS_EXPERIENCE,
//	STATS_GOLD,
//	STATS_GOLDBANK,
//	STATS_ITEM_ARMOR_PERCENT,//0x10
//	STATS_ITEM_MAXDAMAGE_PERCENT,
//	STATS_ITEM_MINDAMAGE_PERCENT,
//	STATS_TOHIT,
//	STATS_TOBLOCK,
//	STATS_MINDAMAGE,
//	STATS_MAXDAMAGE,
//	STATS_SECONDARY_MINDAMAGE,
//	STATS_SECONDARY_MAXDAMAGE,
//	STATS_DAMAGEPERCENT,
//	STATS_MANARECOVERY,
//	STATS_MANARECOVERYBONUS,
//	STATS_STAMINARECOVERYBONUS,
//	STATS_LASTEXP,
//	STATS_NEXTEXP,
//	STATS_ARMORCLASS,
//	STATS_ARMORCLASS_VS_MISSILE,//0x20
//	STATS_ARMORCLASS_VS_HTH,//0x21
//	STATS_NORMAL_DAMAGE_REDUCTION,
//	STATS_MAGIC_DAMAGE_REDUCTION,
//	STATS_DAMAGERESIST,
//	STATS_MAGICRESIST,
//	STATS_MAXMAGICRESIST,
//	STATS_FIRERESIST,//0x27
//	STATS_MAXFIRERESIST,
//	STATS_LIGHTRESIST,//0x29
//	STATS_MAXLIGHTRESIST,
//	STATS_COLDRESIST,//0x2B
//	STATS_MAXCOLDRESIST,
//	STATS_POISONRESIST,
//	STATS_MAXPOISONRESIST,
//	STATS_DAMAGEAURA,
//	STATS_FIREMINDAM,//0x30
//	STATS_FIREMAXDAM,
//	STATS_LIGHTMINDAM,
//	STATS_LIGHTMAXDAM,
//	STATS_MAGICMINDAM,
//	STATS_MAGICMAXDAM,
//	STATS_COLDMINDAM,
//	STATS_COLDMAXDAM,
//	STATS_COLDLENGTH,
//	STATS_POISONMINDAM,
//	STATS_POISONMAXDAM,
//	STATS_POISONLENGTH,
//	STATS_LIFEDRAINMINDAM,
//	STATS_LIFEDRAINMAXDAM,
//	STATS_MANADRAINMINDAM,
//	STATS_MANADRAINMAXDAM,
//	STATS_STAMDRAINMINDAM,//0x40
//	STATS_STAMDRAINMAXDAM,
//	STATS_STUNLENGTH,
//	STATS_VELOCITYPERCENT,
//	STATS_ATTACKRATE,
//	STATS_OTHER_ANIMRATE,
//	STATS_QUANTITY,
//	STATS_VALUE,
//	STATS_DURABILITY,
//	STATS_MAXDURABILITY,
//	STATS_HPREGEN,
//	STATS_ITEM_MAXDURABILITY_PERCENT,
//	STATS_ITEM_MAXHP_PERCENT,
//	STATS_ITEM_MAXMANA_PERCENT,
//	STATS_ITEM_ATTACKERTAKESDAMAGE,
//	STATS_ITEM_GOLDBONUS,
//	STATS_ITEM_MAGICBONUS,//0x50
//	STATS_ITEM_KNOCKBACK,
//	STATS_ITEM_TIMEDURATION,
//	STATS_ITEM_ADDCLASSSKILLS,							//STATS_ITEM_ADDAMASKILLPOINTS
//	STATS_UNSENTPARAM1,									//STATS_ITEM_ADDPALSKILLPOINTS
//	STATS_ADDEXPERIENCE,								//STATS_ITEM_ADDNECSKILLPOINTS
//	STATS_HEALAFTERKILL,								//STATS_ITEM_ADDSORSKILLPOINTS
//	STATS_REDUCESPRICES,								//STATS_ITEM_ADDBARSKILLPOINTS
//	STATS_ITEM_DOUBLEHERBDURATION,
//	STATS_ITEM_LIGHTRADIUS,
//	STATS_ITEM_LIGHTCOLOR,
//	STATS_ITEM_REQ_PERCENT,
//	STATS_LEVELREQ,										//STATS_ITEM_FASTATTACKRATE
//	STATS_ITEM_FASTERATTACKRATE,
//	STATS_ITEM_LEVELREQPCT,								//STATS_ITEM_FASTESTATTACKRATE,
//	STATS_LASTBLOCKFRAME,								//STATS_ITEM_FASTMOVEVELOCITY,
//	STATS_ITEM_FASTERMOVEVELOCITY,//0x60
//	STATS_NONCLASSKILL,									//STATS_ITEM_FASTESTMOVEVELOCITY,
//	STATS_STATE,										//STATS_ITEM_FASTGETHITRATE,
//	STATS_ITEM_FASTERGETHITRATE,
//	STATS_MONSTER_PLAYERCOUNT,							//STATS_ITEM_FASTESTGETHITRATE,
//	STATS_SKILL_POISON_OVERRIDE_LENGTH,					//STATS_ITEM_FASTBLOCKRATE,
//	STATS_ITEM_FASTERBLOCKRATE,
//	STATS_SKILL_BYPASS_UNDEAD,							//STATS_ITEM_FASTESTBLOCKRATE,
//	STATS_SKILL_BYPASS_DEMONS,							//STATS_ITEM_FASTCASTRATE,
//	STATS_ITEM_FASTERCASTRATE,
//	STATS_SKILL_BYPASS_BEASTS,							//STATS_ITEM_FASTESTCASTRATE,
//	STATS_ITEM_SINGLESKILL,								//STATS_ITEM_SINGLESKILL1,
//	STATS_ITEM_RESTINPEACE,								//STATS_ITEM_SINGLESKILL2,
//	STATS_CURSE_RESISTANCE,								//STATS_ITEM_SINGLESKILL3,
//	STATS_ITEM_POISONLENGTHRESIST,
//	STATS_ITEM_NORMALDAMAGE,
//	STATS_ITEM_HOWL,//0x70
//	STATS_ITEM_STUPIDITY,
//	STATS_ITEM_DAMAGETOMANA,
//	STATS_ITEM_IGNORETARGETAC,
//	STATS_ITEM_FRACTIONALTARGETAC,
//	STATS_ITEM_PREVENTHEAL,
//	STATS_ITEM_HALFFREEZEDURATION,
//	STATS_ITEM_TOHIT_PERCENT,
//	STATS_ITEM_DAMAGETARGETAC,
//	STATS_ITEM_DEMONDAMAGE_PERCENT,
//	STATS_ITEM_UNDEADDAMAGE_PERCENT,
//	STATS_ITEM_DEMON_TOHIT,
//	STATS_ITEM_UNDEAD_TOHIT,
//	STATS_ITEM_THROWABLE,
//	STATS_ITEM_ELEMSKILL,								//STATS_ITEM_FIRESKILL,
//	STATS_ITEM_ALLSKILLS,
//	STATS_ITEM_ATTACKERTAKESLIGHTDAMAGE,//0x80
//	STATS_IRONMAIDEN_LEVEL,
//	STATS_LIFETAP_LEVEL,
//	STATS_THORNS_LEVEL,
//	STATS_BONEARMOR,
//	STATS_BONEARMORMAX,
//	STATS_ITEM_FREEZE,
//	STATS_ITEM_OPENWOUNDS,
//	STATS_ITEM_CRUSHINGBLOW,
//	STATS_ITEM_KICKDAMAGE,
//	STATS_ITEM_MANAAFTERKILL,
//	STATS_ITEM_HEALAFTERDEMONKILL,
//	STATS_ITEM_EXTRABLOOD,
//	STATS_ITEM_DEADLYSTRIKE,
//	STATS_ITEM_ABSORBFIRE_PERCENT,
//	STATS_ITEM_ABSORBFIRE,
//	STATS_ITEM_ABSORBLIGHT_PERCENT,
//	STATS_ITEM_ABSORBLIGHT,
//	STATS_ITEM_ABSORBMAGIC_PERCENT,
//	STATS_ITEM_ABSORBMAGIC,
//	STATS_ITEM_ABSORBCOLD_PERCENT,
//	STATS_ITEM_ABSORBCOLD,
//	STATS_ITEM_SLOW,
//	STATS_ITEM_AURA,									//STATS_ITEM_BLESSEDAIM,
//	STATS_ITEM_INDESTRUCTIBLE,							//STATS_ITEM_DEFIANCE,
//	STATS_ITEM_CANNOTBEFROZEN,
//	STATS_ITEM_STAMINADRAINPCT,
//	STATS_ITEM_REANIMATE,
//	STATS_ITEM_PIERCE,
//	STATS_ITEM_MAGICARROW,
//	STATS_ITEM_EXPLOSIVEARROW,
//	STATS_ITEM_THROW_MINDAMAGE,
//	STATS_ITEM_THROW_MAXDAMAGE,
//	STATS_SKILL_HANDOFATHENA,
//	STATS_SKILL_STAMINAPERCENT,
//	STATS_SKILL_PASSIVE_STAMINAPERCENT,
//	STATS_SKILL_CONCENTRATION,
//	STATS_SKILL_ENCHANT,
//	STATS_SKILL_PIERCE,
//	STATS_SKILL_CONVICTION,
//	STATS_SKILL_CHILLINGARMOR,
//	STATS_SKILL_FRENZY,
//	STATS_SKILL_DECREPIFY,
//	STATS_SKILL_ARMOR_PERCENT,
//	STATS_ALIGNMENT,
//	STATS_TARGET0,
//	STATS_TARGET1,
//	STATS_GOLDLOST,
//	STATS_CONVERSION_LEVEL,
//	STATS_CONVERSION_MAXHP,
//	STATS_UNIT_DOOVERLAY,
//	STATS_ATTACK_VS_MONTYPE,							//STATS_ITEM_ADDDRUSKILLPOINTS,
//	STATS_DAMAGE_VS_MONTYPE,							//STATS_ITEM_ADDASSSKILLPOINTS,
//	STATS_FADE,											//STATS_ITEM_ADDSKILL_SINGLE4,
//	STATS_ARMOR_OVERRIDE_PERCENT,						//STATS_ITEM_ADDSKILL_SINGLE5,
//	STATS_UNUSED183,									//STATS_ITEM_ADDSKILL_SINGLE6,
//	STATS_UNUSED184,									//STATS_ITEM_ADDSKILL_SINGLE7,
//	STATS_UNUSED185,									//STATS_ITEM_ADDSKILL_SINGLE8,
//	STATS_UNUSED186,									//STATS_ITEM_ADDSKILL_SINGLE9,
//	STATS_UNUSED187,									//STATS_ITEM_ADDSKILL_SINGLE10,
//	STATS_ADDSKILL_TAB,									//STATS_ITEM_ADDSKILL_TAB1,
//	STATS_UNUSED189,									//STATS_ITEM_ADDSKILL_TAB2,
//	STATS_UNUSED190,									//STATS_ITEM_ADDSKILL_TAB3,
//	STATS_UNUSED191,									//STATS_ITEM_ADDSKILL_TAB4,
//	STATS_UNUSED192,									//STATS_ITEM_ADDSKILL_TAB5,
//	STATS_UNUSED193,									//STATS_ITEM_ADDSKILL_TAB6,
//	STATS_ITEM_NUMSOCKETS,
//	STATS_ITEM_SKILLONATTACK,							//STATS_ITEM_SKILLONATTACK1,
//	STATS_ITEM_SKILLONKILL,								//STATS_ITEM_SKILLONATTACK2,
//	STATS_ITEM_SKILLONDEATH,							//STATS_ITEM_SKILLONATTACK3,
//	STATS_ITEM_SKILLONHIT,								//STATS_ITEM_SKILLONHIT1,
//	STATS_ITEM_SKILLONLEVELUP,							//STATS_ITEM_SKILLONHIT2,
//	STATS_UNUSED200,									//STATS_ITEM_SKILLONHIT3,
//	STATS_ITEM_SKILLONGETHIT,							//STATS_ITEM_SKILLONGETHIT1,
//	STATS_UNUSED202,									//STATS_ITEM_SKILLONGETHIT2,
//	STATS_UNUSED203,									//STATS_ITEM_SKILLONGETHIT3,
//	STATS_ITEM_CHARGED_SKILL,							//STATS_ITEM_CHARGED_SKILL0,
//	STATS_UNUSED205,									//STATS_ITEM_CHARGED_SKILL1,
//	STATS_UNUSED206,									//STATS_ITEM_CHARGED_SKILL2,
//	STATS_UNUSED207,									//STATS_ITEM_CHARGED_SKILL3,
//	STATS_UNUSED208,									//STATS_ITEM_CHARGED_SKILL4,
//	STATS_UNUSED209,									//STATS_ITEM_CHARGED_SKILL5,
//	STATS_UNUSED210,									//STATS_ITEM_CHARGED_SKILL6,
//	STATS_UNUSED211,									//STATS_ITEM_CHARGED_SKILL7,
//	STATS_UNUSED212,									//STATS_ITEM_CHARGED_SKILL8,
//	STATS_UNUSED213,									//STATS_ITEM_CHARGED_SKILL9,
//	STATS_ITEM_ARMOR_PERLEVEL,
//	STATS_ITEM_ARMORPERCENT_PERLEVEL,
//	STATS_ITEM_HP_PERLEVEL,
//	STATS_ITEM_MANA_PERLEVEL,
//	STATS_ITEM_MAXDAMAGE_PERLEVEL,
//	STATS_ITEM_MAXDAMAGE_PERCENT_PERLEVEL,
//	STATS_ITEM_STRENGTH_PERLEVEL,
//	STATS_ITEM_DEXTERITY_PERLEVEL,
//	STATS_ITEM_ENERGY_PERLEVEL,
//	STATS_ITEM_VITALITY_PERLEVEL,
//	STATS_ITEM_TOHIT_PERLEVEL,
//	STATS_ITEM_TOHITPERCENT_PERLEVEL,
//	STATS_ITEM_COLD_DAMAGEMAX_PERLEVEL,
//	STATS_ITEM_FIRE_DAMAGEMAX_PERLEVEL,
//	STATS_ITEM_LTNG_DAMAGEMAX_PERLEVEL,
//	STATS_ITEM_POIS_DAMAGEMAX_PERLEVEL,
//	STATS_ITEM_RESIST_COLD_PERLEVEL,
//	STATS_ITEM_RESIST_FIRE_PERLEVEL,
//	STATS_ITEM_RESIST_LTNG_PERLEVEL,
//	STATS_ITEM_RESIST_POIS_PERLEVEL,
//	STATS_ITEM_ABSORB_COLD_PERLEVEL,
//	STATS_ITEM_ABSORB_FIRE_PERLEVEL,
//	STATS_ITEM_ABSORB_LTNG_PERLEVEL,
//	STATS_ITEM_ABSORB_POIS_PERLEVEL,
//	STATS_ITEM_THORNS_PERLEVEL,
//	STATS_ITEM_FIND_GOLD_PERLEVEL,
//	STATS_ITEM_FIND_MAGIC_PERLEVEL,
//	STATS_ITEM_REGENSTAMINA_PERLEVEL,
//	STATS_ITEM_STAMINA_PERLEVEL,
//	STATS_ITEM_DAMAGE_DEMON_PERLEVEL,
//	STATS_ITEM_DAMAGE_UNDEAD_PERLEVEL,
//	STATS_ITEM_TOHIT_DEMON_PERLEVEL,
//	STATS_ITEM_TOHIT_UNDEAD_PERLEVEL,
//	STATS_ITEM_CRUSHINGBLOW_PERLEVEL,
//	STATS_ITEM_OPENWOUNDS_PERLEVEL,
//	STATS_ITEM_KICK_DAMAGE_PERLEVEL,
//	STATS_ITEM_DEADLYSTRIKE_PERLEVEL,
//	STATS_ITEM_FIND_GEMS_PERLEVEL,
//	STATS_ITEM_REPLENISH_DURABILITY,
//	STATS_ITEM_REPLENISH_QUANTITY,
//	STATS_ITEM_EXTRA_STACK,
//	STATS_ITEM_FIND_ITEM,
//	STATS_ITEM_SLASH_DAMAGE,
//	STATS_ITEM_SLASH_DAMAGE_PERCENT,
//	STATS_ITEM_CRUSH_DAMAGE,
//	STATS_ITEM_CRUSH_DAMAGE_PERCENT,
//	STATS_ITEM_THRUST_DAMAGE,
//	STATS_ITEM_THRUST_DAMAGE_PERCENT,
//	STATS_ITEM_ABSORB_SLASH,
//	STATS_ITEM_ABSORB_CRUSH,
//	STATS_ITEM_ABSORB_THRUST,
//	STATS_ITEM_ABSORB_SLASH_PERCENT,
//	STATS_ITEM_ABSORB_CRUSH_PERCENT,
//	STATS_ITEM_ABSORB_THRUST_PERCENT,
//	STATS_ITEM_ARMOR_BYTIME,
//	STATS_ITEM_ARMORPERCENT_BYTIME,
//	STATS_ITEM_HP_BYTIME,
//	STATS_ITEM_MANA_BYTIME,
//	STATS_ITEM_MAXDAMAGE_BYTIME,
//	STATS_ITEM_MAXDAMAGE_PERCENT_BYTIME,
//	STATS_ITEM_STRENGTH_BYTIME,
//	STATS_ITEM_DEXTERITY_BYTIME,
//	STATS_ITEM_ENERGY_BYTIME,
//	STATS_ITEM_VITALITY_BYTIME,
//	STATS_ITEM_TOHIT_BYTIME,
//	STATS_ITEM_TOHITPERCENT_BYTIME,
//	STATS_ITEM_COLD_DAMAGEMAX_BYTIME,
//	STATS_ITEM_FIRE_DAMAGEMAX_BYTIME,
//	STATS_ITEM_LTNG_DAMAGEMAX_BYTIME,
//	STATS_ITEM_POIS_DAMAGEMAX_BYTIME,
//	STATS_ITEM_RESIST_COLD_BYTIME,
//	STATS_ITEM_RESIST_FIRE_BYTIME,
//	STATS_ITEM_RESIST_LTNG_BYTIME,
//	STATS_ITEM_RESIST_POIS_BYTIME,
//	STATS_ITEM_ABSORB_COLD_BYTIME,
//	STATS_ITEM_ABSORB_FIRE_BYTIME,
//	STATS_ITEM_ABSORB_LTNG_BYTIME,
//	STATS_ITEM_ABSORB_POIS_BYTIME,
//	STATS_ITEM_FIND_GOLD_BYTIME,
//	STATS_ITEM_FIND_MAGIC_BYTIME,
//	STATS_ITEM_REGENSTAMINA_BYTIME,
//	STATS_ITEM_STAMINA_BYTIME,
//	STATS_ITEM_DAMAGE_DEMON_BYTIME,
//	STATS_ITEM_DAMAGE_UNDEAD_BYTIME,
//	STATS_ITEM_TOHIT_DEMON_BYTIME,
//	STATS_ITEM_TOHIT_UNDEAD_BYTIME,
//	STATS_ITEM_CRUSHINGBLOW_BYTIME,
//	STATS_ITEM_OPENWOUNDS_BYTIME,
//	STATS_ITEM_KICK_DAMAGE_BYTIME,
//	STATS_ITEM_DEADLYSTRIKE_BYTIME,
//	STATS_ITEM_FIND_GEMS_BYTIME,
//	STATS_ITEM_PIERCE_COLD,
//	STATS_ITEM_PIERCE_FIRE,
//	STATS_ITEM_PIERCE_LTNG,
//	STATS_ITEM_PIERCE_POIS,
//	STATS_ITEM_DAMAGE_VS_MONSTER,
//	STATS_ITEM_DAMAGE_PERCENT_VS_MONSTER,
//	STATS_ITEM_TOHIT_VS_MONSTER,
//	STATS_ITEM_TOHIT_PERCENT_VS_MONSTER,
//	STATS_ITEM_AC_VS_MONSTER,
//	STATS_ITEM_AC_PERCENT_VS_MONSTER,
//	STATS_FIRELENGTH,
//	STATS_BURNINGMIN,
//	STATS_BURNINGMAX,
//	STATS_PROGRESSIVE_DAMAGE,
//	STATS_PROGRESSIVE_STEAL,
//	STATS_PROGRESSIVE_OTHER,
//	STATS_PROGRESSIVE_FIRE,
//	STATS_PROGRESSIVE_COLD,
//	STATS_PROGRESSIVE_LIGHTNING,
//	STATS_ITEM_EXTRA_CHARGES,
//	STATS_PROGRESSIVE_TOHIT,
//	STATS_POISON_COUNT,
//	STATS_DAMAGE_FRAMERATE,
//	STATS_PIERCE_IDX,
//	STATS_PASSIVE_FIRE_MASTERY,///////////////////////// NEW FOR 1.10
//	STATS_PASSIVE_LTNG_MASTERY,
//	STATS_PASSIVE_COLD_MASTERY,
//	STATS_PASSIVE_POUS_MASTERY,
//	STATS_PASSIVE_FIRE_PIERCE,
//	STATS_PASSIVE_LTNG_PIERCE,
//	STATS_PASSIVE_COLD_PIERCE,
//	STATS_PASSIVE_POIS_PIERCE,
//	STATS_PASSIVE_CRITICAL_STRIKE,
//	STATS_PASSIVE_DODGE,
//	STATS_PASSIVE_AVOID,
//	STATS_PASSIVE_EVADE,
//	STATS_PASSIVE_WARMTH,
//	STATS_PASSIVE_MASTERY_MELEE_TH,
//	STATS_PASSIVE_MASTERY_MELEE_DMG,
//	STATS_PASSIVE_MASTERY_MELEE_CRIT,
//	STATS_PASSIVE_MASTERY_THROW_TH,
//	STATS_PASSIVE_MASTERY_THROW_DMG,
//	STATS_PASSIVE_MASTERY_THROW_CRIT,
//	STATS_PASSIVE_WEAPONBLOCK,
//	STATS_PASSIVE_SUMMON_RESIST,
//	STATS_MODIFIERLIST_SKILL,
//	STATS_MODIFIERLIST_LEVEL,
//	STATS_LAST_SENT_HP_PCT,
//	STATS_SOURCE_UNIT_TYPE,
//	STATS_SOURCE_UNIT_ID,
//	STATS_SHORTPARAM1,
//	STATS_QUESTITEMDIFFICULTY,
//	STATS_PASSIVE_MAG_MASTERY,
//	STATS_PASSIVE_MAG_PIERCE
//};

//enum D2Mod
//{
//	ARMORCLASS = 0,
//	ARMORCLASS_VS_MISSILE,
//	ARMORCLASS_VS_HTH,
//	NORMAL_DAMAGE_REDUCTION,
//	NORMAL_DAMAGE_REDUCTION_PCT,
//	ARMOR_PERCENT,
//	MAGIC_DAMAGE_REDUCTION,
//	STRENGTH,
//	DEXTERITY,
//	VITALITY,
//	ENERGY,
//	MAXMANA,
//	MAXMANA_PERCENT,
//	MAXHP,
//	MAXHP_PERCENT,
//	TOHIT,
//	TOBLOCK,
//	COLDMINDAM,
//	COLDMAXDAM,
//	COLDLENGTH,
//	FIREMINDAM,
//	FIREMAXDAM,
//	LIGHTMINDAM,
//	LIGHTMAXDAM,
//	POISONMINDAM,
//	POISONMAXDAM,
//	POISONLENGTH,
//	MINDAMAGE,
//	MAXDAMAGE,
//	WEAPONDAMAGE_PERCENT,
//	DAMAGETOMANA,
//	FIRERESIST,
//	MAXFIRERESIST,
//	LIGHTRESIST,
//	MAXLIGHTRESIST,
//	COLDRESIST,
//	MAXCOLDRESIST,
//	MAGICRESIST,
//	MAXMAGICRESIST,
//	POISONRESIST,
//	MAXPOISONRESIST,
//	RESISTALL,
//	MAXRESISTALL,
//	ASBORBFIRE_PERCENT,
//	ASBORBFIRE,
//	ASBORBLIGHT_PERCENT,
//	ASBORBLIGHT,
//	ASBORBMAGIC_PERCENT,
//	ASBORBMAGIC,
//	ASBORBCOLD_PERCENT,
//	ASBORBCOLD,
//	MAXDURABILITY,
//	MAXDURABILITY_PERCENT,
//	HITPOINTS_DELTA,
//	ATTACKERTAKES_DAMAGE,
//	FASTATTACKRATE,
//	FASTERATTACKRATE,
//	FASTESTATTACKRATE,
//	GOLDBONUS,
//	MAGICBONUS,
//	KNOCKBACK,
//	REGENSTAMINA_PERCENT,
//	REGENMANA_PERCENT,
//	BASESTAMINA,
//	TIMEDURATION,
//	MANASTEAL,
//	LIFESTEAL,
//	ADDAMASKILLPOINTS,
//	ADDPALSKILLPOINTS,
//	ADDNECSKILLPOINTS,
//	ADDSORSKILLPOINTS,
//	ADDBARSKILLPOINTS,
//	DOUBLEHERBDURATION,
//	LIGHTRADIUS,
//	LIGHTCOLOR,
//	REQ_PERCENT,
//	FASTMOVEVELOCITY,
//	FASTERMOVEVELOCITY,
//	FASTESTMOVEVELOCITY,
//	FASTGETHITRATE,
//	FASTERGETHITRATE,
//	FASTESTGETHITRATE,
//	FASTBLOCKRATE,
//	FASTERBLOCKRATE,
//	FASTESTBLOCKRATE,
//	FASTCASTRATE,
//	FASTERCASTRATE,
//	FASTESTCASTRATE,
//	POISONLENGTHRESIST,
//	NORMALDAMAGE,
//	HOWL,
//	STUPIDITY,
//	IGNORETARGETAC,
//	FRACTIONALTARGETAC,
//	PREVENTHEAL,
//	HALFFREEZEDURATION,
//	TOHIT_PERCENT,
//	DAMAGETARGETAC,
//	DEMONDAMAGE_PERCENT,
//	UNDEADDAMAGE_PERCENT,
//	DEMON_TOHIT,
//	UNDEAD_TOHIT,
//	THROWABLE,
//	FIRESKILL,
//	ALLSKILLS,
//	ATTACKERTAKESLIGHT_DAMAGE,
//	FREEZE,
//	OPENWOUNDS,
//	CRUSHINGBLOW,
//	KICKDAMAGE,
//	MANAAFTERKILL,
//	HEALAFTERDEMONKILL,
//	EXTRABLOOD,
//	DEADLYSTRIKE,
//	SLOW,
//	CANNOTBEFROZEN,
//	STAMINADRAINPCT,
//	REANIMATE,
//	PIERCE,
//	MAGICARROW,
//	EXPLOSIVEARROW,
//	ADDDRUSKILLPOINTS,
//	ADDASSSKILLPOINTS,
//	ADDSKILL,
//	ADDTAB,
//	ADDSKILL_PASSIVES,
//	SKILL_ON_ATTACK,
//	SKILL_ON_HIT,
//	SKILL_ON_GETHIT,
//	GEMBONUS,
//	DURABILITY_OVER_TIME,
//	FIRE_EFFECTS,
//	LIGHTNING_EFFECTS,
//	SOCKETS,
//	FIRE_DAMAGE_MINMAX,
//	LIGHT_DAMAGE_MINMAX,
//	MAGIC_DAMAGE_MINMAX,
//	COLD_DAMAGE_MINMAXLEN,
//	POIS_DAMAGE_MINMAXLEN,
//	THROW_DAMAGE_MINMAX,
//	DAMAGE_MINMAX,
//	STATS_ITEM_ARMOR_PERLEVEL_MOD,
//	STATS_ITEM_ARMORPERCENT_PERLEVEL_MOD,
//	STATS_ITEM_HP_PERLEVEL_MOD,
//	STATS_ITEM_MANA_PERLEVEL_MOD,
//	STATS_ITEM_MAXDAMAGE_PERLEVEL_MOD,
//	STATS_ITEM_MAXDAMAGE_PERCENT_PERLEVEL_MOD,
//	STATS_ITEM_STRENGTH_PERLEVEL_MOD,
//	STATS_ITEM_DEXTERITY_PERLEVEL_MOD,
//	STATS_ITEM_ENERGY_PERLEVEL_MOD,
//	STATS_ITEM_VITALITY_PERLEVEL_MOD,
//	STATS_ITEM_TOHIT_PERLEVEL_MOD,
//	STATS_ITEM_TOHITPERCENT_PERLEVEL_MOD,
//	STATS_ITEM_COLD_DAMAGEMAX_PERLEVEL_MOD,
//	STATS_ITEM_FIRE_DAMAGEMAX_PERLEVEL_MOD,
//	STATS_ITEM_LTNG_DAMAGEMAX_PERLEVEL_MOD,
//	STATS_ITEM_POIS_DAMAGEMAX_PERLEVEL_MOD,
//	STATS_ITEM_RESIST_COLD_PERLEVEL_MOD,
//	STATS_ITEM_RESIST_FIRE_PERLEVEL_MOD,
//	STATS_ITEM_RESIST_LTNG_PERLEVEL_MOD,
//	STATS_ITEM_RESIST_POIS_PERLEVEL_MOD,
//	STATS_ITEM_ABSORB_COLD_PERLEVEL_MOD,
//	STATS_ITEM_ABSORB_FIRE_PERLEVEL_MOD,
//	STATS_ITEM_ABSORB_LTNG_PERLEVEL_MOD,
//	STATS_ITEM_ABSORB_POIS_PERLEVEL_MOD,
//	STATS_ITEM_THORNS_PERLEVEL_MOD,
//	STATS_ITEM_FIND_GOLD_PERLEVEL_MOD,
//	STATS_ITEM_FIND_MAGIC_PERLEVEL_MOD,
//	STATS_ITEM_REGENSTAMINA_PERLEVEL_MOD,
//	STATS_ITEM_STAMINA_PERLEVEL_MOD,
//	STATS_ITEM_DAMAGE_DEMON_PERLEVEL_MOD,
//	STATS_ITEM_DAMAGE_UNDEAD_PERLEVEL_MOD,
//	STATS_ITEM_TOHIT_DEMON_PERLEVEL_MOD,
//	STATS_ITEM_TOHIT_UNDEAD_PERLEVEL_MOD,
//	STATS_ITEM_CRUSHINGBLOW_PERLEVEL_MOD,
//	STATS_ITEM_OPENWOUNDS_PERLEVEL_MOD,
//	STATS_ITEM_KICK_DAMAGE_PERLEVEL_MOD,
//	STATS_ITEM_DEADLYSTRIKE_PERLEVEL_MOD,
//	STATS_ITEM_FIND_GEMS_PERLEVEL_MOD,
//	STATS_ITEM_REPLENISH_DURABILITY_MOD,
//	STATS_ITEM_REPLENISH_QUANTITY_MOD,
//	STATS_ITEM_EXTRA_STACK_MOD,
//	STATS_ITEM_FIND_ITEM_MOD,
//	STATS_ITEM_SLASH_DAMAGE_MOD,
//	STATS_ITEM_SLASH_DAMAGE_PERCENT_MOD,
//	STATS_ITEM_CRUSH_DAMAGE_MOD,
//	STATS_ITEM_CRUSH_DAMAGE_PERCENT_MOD,
//	STATS_ITEM_THRUST_DAMAGE_MOD,
//	STATS_ITEM_THRUST_DAMAGE_PERCENT_MOD,
//	STATS_ITEM_ABSORB_SLASH_MOD,
//	STATS_ITEM_ABSORB_CRUSH_MOD,
//	STATS_ITEM_ABSORB_THRUST_MOD,
//	STATS_ITEM_ABSORB_SLASH_PERCENT_MOD,
//	STATS_ITEM_ABSORB_CRUSH_PERCENT_MOD,
//	STATS_ITEM_ABSORB_THRUST_PERCENT_MOD,
//	STATS_ITEM_ARMOR_BYTIME_MOD,
//	STATS_ITEM_ARMORPERCENT_BYTIME_MOD,
//	STATS_ITEM_HP_BYTIME_MOD,
//	STATS_ITEM_MANA_BYTIME_MOD,
//	STATS_ITEM_MAXDAMAGE_BYTIME_MOD,
//	STATS_ITEM_MAXDAMAGE_PERCENT_BYTIME_MOD,
//	STATS_ITEM_STRENGTH_BYTIME_MOD,
//	STATS_ITEM_DEXTERITY_BYTIME_MOD,
//	STATS_ITEM_ENERGY_BYTIME_MOD,
//	STATS_ITEM_VITALITY_BYTIME_MOD,
//	STATS_ITEM_TOHIT_BYTIME_MOD,
//	STATS_ITEM_TOHITPERCENT_BYTIME_MOD,
//	STATS_ITEM_COLD_DAMAGEMAX_BYTIME_MOD,
//	STATS_ITEM_FIRE_DAMAGEMAX_BYTIME_MOD,
//	STATS_ITEM_LTNG_DAMAGEMAX_BYTIME_MOD,
//	STATS_ITEM_POIS_DAMAGEMAX_BYTIME_MOD,
//	STATS_ITEM_RESIST_COLD_BYTIME_MOD,
//	STATS_ITEM_RESIST_FIRE_BYTIME_MOD,
//	STATS_ITEM_RESIST_LTNG_BYTIME_MOD,
//	STATS_ITEM_RESIST_POIS_BYTIME_MOD,
//	STATS_ITEM_ABSORB_COLD_BYTIME_MOD,
//	STATS_ITEM_ABSORB_FIRE_BYTIME_MOD,
//	STATS_ITEM_ABSORB_LTNG_BYTIME_MOD,
//	STATS_ITEM_ABSORB_POIS_BYTIME_MOD,
//	STATS_ITEM_FIND_GOLD_BYTIME_MOD,
//	STATS_ITEM_FIND_MAGIC_BYTIME_MOD,
//	STATS_ITEM_REGENSTAMINA_BYTIME_MOD,
//	STATS_ITEM_STAMINA_BYTIME_MOD,
//	STATS_ITEM_DAMAGE_DEMON_BYTIME_MOD,
//	STATS_ITEM_DAMAGE_UNDEAD_BYTIME_MOD,
//	STATS_ITEM_TOHIT_DEMON_BYTIME_MOD,
//	STATS_ITEM_TOHIT_UNDEAD_BYTIME_MOD,
//	STATS_ITEM_CRUSHINGBLOW_BYTIME_MOD,
//	STATS_ITEM_OPENWOUNDS_BYTIME_MOD,
//	STATS_ITEM_KICK_DAMAGE_BYTIME_MOD,
//	STATS_ITEM_DEADLYSTRIKE_BYTIME_MOD,
//	STATS_ITEM_FIND_GEMS_BYTIME_MOD,
//	STATS_ITEM_PIERCE_COLD_MOD,
//	STATS_ITEM_PIERCE_FIRE_MOD,
//	STATS_ITEM_PIERCE_LTNG_MOD,
//	STATS_ITEM_PIERCE_POIS_MOD,
//	STATS_ITEM_DAMAGE_VS_MONSTER_MOD,
//	STATS_ITEM_DAMAGE_PERCENT_VS_MONSTER_MOD,
//	STATS_ITEM_TOHIT_VS_MONSTER_MOD,
//	STATS_ITEM_TOHIT_PERCENT_VS_MONSTER_MOD,
//	STATS_ITEM_AC_VS_MONSTER_MOD,
//	STATS_ITEM_AC_PERCENT_VS_MONSTER_MOD,
//	INDESTRUCTIBLE,
//	STATS_ITEM_CHARGED_SKILL_MOD
//};
//
//enum D2ItemFlags
//{
//	ITEMFLAG_NEWITEM          = 0x00000001,
//	ITEMFLAG_MAGICAL          = 0x00000010,
//	ITEMFLAG_SOCKETED         = 0x00000800,
//	ITEMFLAG_EAR              = 0x00001000,
//	ITEMFLAG_NEWITEM2         = 0x00002000,
//	ITEMFLAG_CHECKSECPRICE    = 0x00010000,
//	ITEMFLAG_CHACKGAMBLEPRICE = 0x00020000,
//	ITEMFLAG_ETHERAL          = 0x00400000,
//	ITEMFLAG_FROMPLAYER       = 0x01000000
//};
//
//enum D2ItemTtype
//{
//	TYPE_NONE0 = 0,
//	TYPE_NONE1,
//	TYPE_SHIELD,
//	TYPR_ARMOR,
//	TYPE_GOLD,
//	TYPE_BOW_QUIVER,
//	TYPE_CROSSBOW_QUIVER,
//	TYPE_PLAYER_BODY_PART,
//	TYPE_HERB,
//	TYPE_POTION,
//	TYPE_RING,
//	TYPE_ELIXIR,
//	TYPE_AMULET,
//	TYPE_CHARM,
//	TYPE_NOT_USED14,
//	TYPE_BOOTS,
//	TYPE_GLOVES,
//	TYPE_NOT_USED17,
//	TYPE_BOOK,
//	TYPE_BELT,
//	TYPE_GEM,
//	TYPE_TORCH,
//	TYPE_SCROLL,
//	TYPE_NOT_USED23,
//	TYPE_SCEPTER,
//	TYPE_WAND,
//	TYPE_STAFF,
//	TYPE_BOW,
//	TYPE_AXE,
//	TYPE_CLUB,
//	TYPE_SWORD,
//	TYPE_HAMMER,
//	TYPE_KNIFE,
//	TYPE_SPEAR,
//	TYPE_POLEARM,
//	TYPE_CROSSBOW,
//	TYPE_MACE,
//	TYPE_HELM,
//	TYPE_MISSILE_POTION,
//	TYPE_QUEST,
//	TYPE_BODY_PART,
//	TYPE_KEY,
//	TYPE_THROWING_KNIFE,
//	TYPE_THROWING_AXE,
//	TYPE_JAVELIN,
//	TYPE_WEAPON,
//	TYPE_MELEE_WEAPON,
//	TYPE_MISSILE_WEAPON,
//	TYPE_THROWN_WEAPON,
//	TYPE_COMBO_WEAPON,
//	TYPE_ANY_ARMOR,
//	TYPE_ANY_SHIELD,
//	TYPE_MISCELLANEOUS,
//	TYPE_SOCKET_FILLER,
//	TYPE_SECOND_HAND,
//	TYPE_STAVES_AND_RODS,
//	TYPE_MISSILE,
//	TYPE_BLUNT,
//	//Expansion
//	TYPE_JEWEL,
//	TYPE_CLASS_SPECIFIC,
//	TYPE_AMAZON_ITEM,
//	TYPE_BARBARIAN_ITEM,
//	TYPE_NECROMANCER_ITEM,
//	TYPE_PALADIN_ITEM,
//	TYPE_SORCERESS_ITEM,
//	TYPE_ASSASSIN_ITEM,
//	TYPE_DRUID_ITEM,
//	TYPE_HAND_TO_HAND,
//	TYPE_ORB,
//	TYPE_VOODOO_HEADS,
//	TYPE_AURIC_SHIELDS,
//	TYPE_PRIMAL_HELM,
//	TYPE_PELT,
//	TYPE_CLOAK,
//	TYPE_RUNE,
//	TYPE_CIRCLET,
//	TYPE_HEALING_POTION,
//	TYPE_MANA_POTION,
//	TYPE_REJUV_POTION,
//	TYPE_STAMINA_POTION,
//	TYPE_ANTIDOTE_POTION,
//	TYPE_THAWING_POTION,
//	TYPE_SMALL_CHARM,
//	TYPE_MEDIUM_CHARM,
//	TYPE_LARGE_CHARM,
//	TYPE_AMAZON_BOW,
//	TYPE_AMAZON_SPEAR,
//	TYPE_AMAZON_JAVELIN,
//	TYPE_HAND_TO_HAND2,
//	TYPE_MAGIC_BOW_QUIVER,
//	TYPE_MAGIC_CROSSBOW_QUIVER,
//	TYPE_CHIPPED_GEM,
//	TYPE_FLAWED_GEM,
//	TYPE_STANDARD_GEM,
//	TYPE_FLAWLESS_GEM,
//	TYPE_PERFECT_GEM,
//	TYPE_AMETHYST,
//	TYPE_DIAMOND,
//	TYPE_EMERALD,
//	TYPE_RUBY,
//	TYPE_SAPPHIRE,
//	TYPE_TOPAZ,
//	TYPE_SKULL
//};
//
//enum D2ItemQuality
//{
//	ITEMQUALITY_CRACKED = 1,
//	ITEMQUALITY_NORMAL,
//	ITEMQUALITY_SUPERIOR,
//	ITEMQUALITY_MAGIC,
//	ITEMQUALITY_SET,
//	ITEMQUALITY_RARE,
//	ITEMQUALITY_UNIQUE,
//	ITEMQUALITY_CRAFTED,
//	ITEMQUALITY_TEMPERED
//};
//
//enum D2UnitType
//{
//	UNIT_PLAYER = 0,
//	UNIT_MONSTER,
//	UNIT_OBJECT,
//	UNIT_MISSILE,
//	UNIT_ITEM,
//	UNIT_ROOMTILE
//};
//
//enum D2BodyLoc
//{
//	LOC_HEAD =1,
//	LOC_NECK,
//	LOC_TORS,
//	LOC_RARM,
//	LOC_LARM,
//	LOC_LRIN,
//	LOC_RRIN,
//	LOC_BELT,
//	LOC_FEET,
//	LOC_GLOV,
//	LOC_RALT,
//	LOC_LALT
//};
//
//enum D2UIwindow_t {
//	UI_WINDOW_INVENTORY = 0x01,
//	UI_WINDOW_CHARACTER = 0x02,
//	UI_WINDOW_MINISKILL = 0x03,
//	UI_WINDOW_SKILL = 0x04,
//	UI_WINDOW_CHAT = 0x05,
//	UI_WINDOW_NPCMENU = 0x08,
//	UI_WINDOW_MAINMENU = 0x09,
//	UI_WINDOW_AUTOMAP = 0x0a,
//	UI_WINDOW_CONFIG = 0x0b,
//	UI_WINDOW_NPCSHOP = 0x0c,
//	UI_WINDOW_ALTDOWN = 0x0d,
//	UI_WINDOW_ANVIL = 0x0e,
//	UI_WINDOW_QUEST = 0x0f,
//	UI_WINDOW_QUESTLOG = 0x11,
//	UI_WINDOW_STATUSAREA = 0x12,
//	UI_WINDOW_WPMENU = 0x14,
//	UI_WINDOW_MINIPANEL = 0x15,
//	UI_WINDOW_PARTY = 0x16,
//	UI_WINDOW_TRADE = 0x17,
//	UI_WINDOW_MSGS = 0x18,
//	UI_WINDOW_STASH = 0x19,
//	UI_WINDOW_CUBE = 0x1a,
//	UI_WINDOW_BELT = 0x1f,
//	UI_WINDOW_HELP = 0x21,
//	UI_WINDOW_MERC = 0x24,
//	UI_WINDOW_SCROLL = 0x25
//};
//
//
//////////////////////////////////////////////////////////////////////
//// Item Related
//////////////////////////////////////////////////////////////////////
//#define	ITEM_MESSAGEID_DROP				0x9C // drop/pick from belt/ground
//#define	ITEM_MESSAGEID_OPERATE			0x9D // pick/equip
//
//#define	ITEM_ACTION_NEW_GROUND			0x00 //9c
//#define	ITEM_ACTION_PICK_UP				0x01 //9c
//#define	ITEM_ACTION_DROP				0x02 //9c
//#define	ITEM_ACTION_OLD_GROUND			0x03 //9c
//#define	ITEM_ACTION_TO_STORAGE			0x04 //9c
//#define	ITEM_ACTION_FROM_STORAGE		0x05 //9d
//#define	ITEM_ACTION_TO_EQUIP			0x06 //9d
//#define	ITEM_ACTION_FROM_EQUIP			0x08 //9d
//#define	ITEM_ACTION_SWITCH_EQUIP		0x09 //9d
//#define	ITEM_ACTION_TO_STORE			0x0B //9c
//#define	ITEM_ACTION_FROM_STORE			0x0C //9c
//#define	ITEM_ACTION_SWITCH_STORAGE		0x0d //9c
//#define	ITEM_ACTION_TO_BELTSLOT			0x0E //9c
//#define	ITEM_ACTION_FROM_BELTSLOT		0x0F //9c
//#define	ITEM_ACTION_SWITCH_BELTSLOT		0x10 //9c
//#define ITEM_ACTION_TO_CURSOR			0x12 //9c
//#define ITEM_ACTION_SHIFT_BELTSLOT		0x15 //9d
//
//#define	ITEM_ITEMTYPE_HELM				0x00
//#define	ITEM_ITEMTYPE_ARMOR				0x01
//#define	ITEM_ITEMTYPE_WEAPON			0x05
//#define	ITEM_ITEMTYPE_BOW				0x06
//#define	ITEM_ITEMTYPE_SHIELD			0x07
//#define	ITEM_ITEMTYPE_EXPANSION			0x0A // heads
//#define	ITEM_ITEMTYPE_OTHER				0x10
//
//// Drop locations
//#define	ITEM_LOCAIION_STORED			0x00
//#define	ITEM_LOCATION_WORN				0x01
//#define	ITEM_LOCATION_BELT				0x02
//#define	ITEM_LOCATION_GROUND			0x03
//#define	ITEM_LOCATION_TOHAND			0x04
//
//// Item levels
//#define	ITEM_LEVEL_INFERIOR				0x01
//#define	ITEM_LEVEL_NORMAL				0x02
//#define	ITEM_LEVEL_SUPERIOR				0x03
//#define	ITEM_LEVEL_MAGIC				0x04
//#define	ITEM_LEVEL_SET					0x05
//#define	ITEM_LEVEL_RARE					0x06
//#define	ITEM_LEVEL_UNIQUE				0x07
//#define	ITEM_LEVEL_CRAFT				0x08
//#define	ITEM_INFERIORTYPE_CRUDE			0x00
//#define	ITEM_INFERIORTYPE_CRACKED		0x01
//#define	ITEM_INFERIORTYPE_DAMAGED		0x02
//#define	ITEM_INFERIORTYPE_LOWQUALITY	0x04
//#define	ITEM_SUPERIOR_AR				0x00
//#define	ITEM_SUPERIOR_MAXDMG			0x01
//#define	ITEM_SUPERIOR_AC				0x02
//#define	ITEM_SUPERIOR_AR_MAXDMG			0x03
//#define	ITEM_SUPERIOR_DUR				0x04
//#define	ITEM_SUPERIOR_DUR_AR			0x05
//#define	ITEM_SUPERIOR_DUR_MAXDMG		0x06
//#define	ITEM_SUPERIOR_DUR_AC			0x07
//
//// Gold sizes
//#define	ITEM_GOLDSIZE_12BIT				0x00
//#define	ITEM_GOLDSIZE_32BIT				0x01
//#define	ITEM_UNSET						0xFF
//
//
/////////////////////////////////////////////////////////////////
////    Common Spells
/////////////////////////////////////////////////////////////////
//
//#define D2S_INVALID				0xffff // should never happen
//#define D2S_ATTACK				0x0000
//#define D2S_KICK				0x0001
//#define D2S_THROW				0x0002
//#define D2S_UNSUMMON			0x0003
//#define D2S_LEFTTHROW			0x0004
//#define D2S_LEFTSWING			0x0005
//#define D2S_TOMEOFIDENTIFY		0x00da
//#define D2S_SCROLLOFIDENTIFY	0x00d9
//#define D2S_TOMEOFTOWNPORTAL	0x00dc
//#define D2S_SCROLLOFTOWNPORTAL	0x00db
//
/////////////////////////////////////////////////////////////////
////    Amazon Spells
/////////////////////////////////////////////////////////////////
//
//// Javelin and Spear spells
//#define D2S_JAB					0x000a
//#define D2S_IMPALE				0x0013
//#define D2S_FEND				0x001e
//#define D2S_POWERSTRIKE			0x000e
//#define D2S_CHARGEDSTRIKE		0x0018
//#define D2S_LIGHTNINGSTRIKE		0x0022
//#define D2S_POISONJAVELIN		0x000f
//#define D2S_LIGHTNINGBOLT		0x0014
//#define D2S_PLAGUEJAVELIN		0x0019
//#define D2S_LIGHTNINGFURY		0x0023
//
//// Passive and Magic spells
//#define D2S_INNERSIGHT			0x0008
//#define D2S_SLOWMISSILES		0x0011
//#define D2S_DECOY				0x001c
//#define D2S_VALKYRIE			0x0020
//#define D2S_DODGE				0x000d
//#define D2S_AVOID				0x0012
//#define D2S_EVADE				0x001d
//#define D2S_CRITICALSTRIKE		0x0009
//#define D2S_PENETRATE			0x0017
//#define D2S_PIERCE				0x0021
//
//// Bow and Crossbow spells
//#define D2S_COLDARROW			0x000b
//#define D2S_ICEARROW			0x0015
//#define D2S_FREEZINGARROW		0x001f
//#define D2S_MAGICARROW			0x0006
//#define D2S_MULTIPLESHOT		0x000c
//#define D2S_GUIDEDARROW			0x0016
//#define D2S_STRAFE				0x001a
//#define D2S_FIREARROW			0x0007
//#define D2S_EXPLODINGARROW		0x0010
//#define D2S_IMMOLATIONARROW		0x001b
//
//
/////////////////////////////////////////////////////////////////
////    Assassin Spells
/////////////////////////////////////////////////////////////////
//
//// Martial Arts
//#define D2S_FISTSOFFIRE			0x0103
//#define D2S_CLAWSOFTHUNDER		0x010d
//#define D2S_BLADESOFICE			0x0112
//#define D2S_TIGERSTRIKE			0x00fe
//#define D2S_COBRASTRIKE			0x0109
//#define D2S_PHOENIXSTRIKE		0x0118
//#define D2S_DRAGONTALON			0x00ff
//#define D2S_DRAGONCLAW			0x0104
//#define D2S_DRAGONTAIL			0x010e
//#define D2S_DRAGONFLIGHT		0x0113
//
//// Shadow Disciplines
//#define D2S_BURSTOFSPEED		0x0102
//#define D2S_FADE				0x010b
//#define D2S_VENOM				0x0116
//#define D2S_CLAWMASTERY			0x00fc
//#define D2S_WEAPONBLOCK			0x0107
//#define D2S_SHADOWWARRIOR		0x010c
//#define D2S_SHADOWMASTER		0x0117
//#define D2S_PSYCHICHAMMER		0x00fd
//#define D2S_CLOAKOFSHADOWS		0x0108
//#define D2S_MINDBLAST			0x0111
//
//// Traps
//#define D2S_SHOCKWEB			0x0100
//#define D2S_CHARGEDBOLTSENTRY	0x0105
//#define D2S_LIGHTNINGSENTRY		0x010f
//#define D2S_DEATHSENTRY			0x0114
//#define D2S_FIREBLAST			0x00fb
//#define D2S_WAKEOFFIRE			0x0106
//#define D2S_WAKEOFINFERNO		0x0110
//#define D2S_BLADESENTINEL		0x0101
//#define D2S_BLADEFURY			0x010a
//#define D2S_BLADESHIELD			0x0115
//
//
/////////////////////////////////////////////////////////////////
////    Barbarian Spells
/////////////////////////////////////////////////////////////////
//
//// Warcries
//#define D2S_HOWL				0x0082
//#define D2S_TAUNT				0x0089
//#define D2S_BATTLECRY			0x0092
//#define D2S_WARCRY				0x009a
//#define D2S_SHOUT				0x008a
//#define D2S_BATTLEORDERS		0x0095
//#define D2S_BATTLECOMMAND		0x009b
//#define D2S_FINDPOTION			0x0083
//#define D2S_FINDITEM			0x008e
//#define D2S_GRIMWARD			0x0096
//
//// Combat Masteries
//#define D2S_SWORDMASTERY		0x007f
//#define D2S_POLEARMMASTERY		0x0086
//#define D2S_INCREASEDSTAMINA	0x008d
//#define D2S_INCREASEDSPEED		0x0094
//#define D2S_AXEMASTERY			0x0080
//#define D2S_THROWINGMASTERY		0x0087
//#define D2S_MACEMASTERY			0x0081
//#define D2S_SPEARMASTERY		0x0088
//#define D2S_IRONSKIN			0x0091
//#define D2S_NATURALRESISTANCE	0x0099
//
//// Combat spells
//#define D2S_LEAP				0x0084
//#define D2S_LEAPATTACK			0x008f
//#define D2S_WHIRLWIND			0x0097
//#define D2S_BASH				0x007e
//#define D2S_STUN				0x008b
//#define D2S_CONCENTRATE			0x0090
//#define D2S_BERSERK				0x0098
//#define D2S_DOUBLESWING			0x0085
//#define D2S_DOUBLETHROW			0x008c
//#define D2S_FRENZY				0x0093
//
//
/////////////////////////////////////////////////////////////////
////    Druid Spells
/////////////////////////////////////////////////////////////////
//
//// Elemental
//#define D2S_FIRESTORM			0x00e1
//#define D2S_MOLTENBOULDER		0x00e5
//#define D2S_FISSURE				0x00ea
//#define D2S_VOLCANO				0x00f4
//#define D2S_ARMAGEDDON			0x00f9
//#define D2S_TWISTER				0x00f0
//#define D2S_TORNADO				0x00f5
//#define D2S_HURRICANE			0x00fa
//#define D2S_ARCTICBLAST			0x00e6
//#define D2S_CYCLONEARMOR		0x00eb
//
//// Shape Shifting
//#define D2S_WEREWOLF			0x00df
//#define D2S_FERALRAGE			0x00e8
//#define D2S_RABIES				0x00ee
//#define D2S_FURY				0x00f8
//#define D2S_LYCANTHROPY			0x00e0
//#define D2S_FIRECLAWS			0x00ef
//#define D2S_HUNGER				0x00f2
//#define D2S_WEREBEAR			0x00e4
//#define D2S_MAUL				0x00e9
//#define D2S_SHOCKWAVE			0x00f3
//
//// Summoning
//#define D2S_OAKSAGE				0x00e2
//#define D2S_HEARTOFWOLVERINE	0x00ec
//#define D2S_SPIRITOFBARBS		0x00f6
//#define D2S_RAVEN				0x00dd
//#define D2S_SUMMONSPIRITWOLF	0x00e3
//#define D2S_SUMMONDIREWOLF		0x00ed
//#define D2S_SUMMONGRIZZLY		0x00f7
//#define D2S_POISONCREEPER		0x00de
//#define D2S_CARRIONVINE			0x00e7
//#define D2S_SOLARCREEPER		0x00f1
//
//
/////////////////////////////////////////////////////////////////
////    Necromancer Spells
/////////////////////////////////////////////////////////////////
//
//// Summoning Spells
//#define D2S_SKELETONMASTERY		0x0045
//#define D2S_GOLEMMASTERY		0x004f
//#define D2S_SUMMONRESIST		0x0059
//#define D2S_CLAYGOLEM			0x004b
//#define D2S_BLOODGOLEM			0x0055
//#define D2S_IRONGOLEM			0x005a
//#define D2S_FIREGOLEM			0x005e
//#define D2S_RAISESKELETON		0x0046
//#define D2S_RAISESKELETALMAGE	0x0050
//#define D2S_REVIVE				0x005f
//
//// Poison and Bone Spells
//#define D2S_POISONDAGGER		0x0049
//#define D2S_POISONEXPLOSION		0x0053
//#define D2S_POISONNOVA			0x005c
//#define D2S_TEETH				0x0043
//#define D2S_CORPOSEEXPLOSION	0x004a
//#define D2S_BONESPEAR			0x0054
//#define D2S_BONESPIRIT			0x005d
//#define D2S_BONEARMOR			0x0044
//#define D2S_BONEWALL			0x004e
//#define D2S_BONEPRISON			0x0058
//
//// Curses
//#define D2S_DIMVISION			0x0047
//#define D2S_CONFUSE				0x0051
//#define D2S_ATTRACT				0x0056
//#define D2S_AMPLIFYDAMAGE		0x0042
//#define D2S_IRONMAIDEN			0x004c
//#define D2S_LIFETAP				0x0052
//#define D2S_LOWERRESIST			0x005b
//#define D2S_WEAKEN				0x0048
//#define D2S_TERROR				0x004d
//#define D2S_DECREPIFY			0x0057
//
//
/////////////////////////////////////////////////////////////////
////    Paladin Spells
/////////////////////////////////////////////////////////////////
//
//// Defensive Auras
//#define D2S_PRAYER				0x0063
//#define D2S_CLEANSING			0x006d
//#define D2S_MEDITATION			0x0078
//#define D2S_DEFIANCE			0x0068
//#define D2S_VIGOR				0x0073
//#define D2S_REDEMPTION			0x007c
//#define D2S_RESISTFIRE			0x0064
//#define D2S_RESISTCOLD			0x0069
//#define D2S_RESISTLIGHTNING		0x006e
//#define D2S_SALVATION			0x007d
//
//// Offensive Auras
//#define D2S_MIGHT				0x0062
//#define D2S_BLESSEDAIM			0x006c
//#define D2S_CONCENTRATION		0x0071
//#define D2S_FANATICISM			0x007a
//#define D2S_HOLYFIRE			0x0066
//#define D2S_HOLYFREEZE			0x0072
//#define D2S_HOLYSHOCK			0x0076
//#define D2S_THORNS				0x0067
//#define D2S_SANCTUARY			0x0077
//#define D2S_CONVICTION			0x007b
//
//// Combat spells
//#define D2S_SACRIFICE			0x0060
//#define D2S_ZEAL				0x006a
//#define D2S_VENGEANCE			0x006f
//#define D2S_CONVERSION			0x0074
//#define D2S_HOLYBOLT			0x0065
//#define D2S_BLESSEDHAMMER		0x0070
//#define D2S_FISTOFTHEHEAVENS	0x0079
//#define D2S_SMITE				0x0061
//#define D2S_CHARGE				0x006b
//#define D2S_HOLYSHIELD			0x0075
//
//
/////////////////////////////////////////////////////////////////
////    Sorceress Spells
/////////////////////////////////////////////////////////////////
//
//// Cold Spells
//#define D2S_FROSTNOVA			0x002c
//#define D2S_BLIZZARD			0x003b
//#define D2S_FROZENORB			0x0040
//#define D2S_ICEBOLT				0x0027
//#define D2S_ICEBLAST			0x002d
//#define D2S_GLACIALSPIKE		0x0037
//#define D2S_COLDMASTERY			0x0041
//#define D2S_FROZENARMOR			0x0028
//#define D2S_SHIVERARMOR			0x0032
//#define D2S_CHILLINGARMOR		0x003c
//
//// Lightning Spells
//#define D2S_STATICFIELD			0x002a
//#define D2S_NOVA				0x0030
//#define D2S_THUNDERSTORM		0x0039
//#define D2S_CHARGEDBOLT			0x0026
//#define D2S_LIGHTNING			0x0031
//#define D2S_CHAINLIGHTNING		0x0035
//#define D2S_LIGHTNINGMASTERY	0x003f
//#define D2S_TELEKINESIS			0x002b
//#define D2S_TELEPORT			0x0036
//#define D2S_ENERGYSHIELD		0x003a
//
//// Fire Spells
//#define D2S_INFERNO				0x0029
//#define D2S_BLAZE				0x002e
//#define D2S_FIREWALL			0x0033
//#define D2S_FIREBOLT			0x0024
//#define D2S_FIREBALL			0x002f
//#define D2S_METEOR				0x0038
//#define D2S_FIREMASTERY			0x003d
//#define D2S_WARMTH				0x0025
//#define D2S_ENCHANT				0x0034
//#define D2S_HYDRA				0x003e

// end of file ---------------------------------------------------------------
#endif